package org.maxsite;
/*
* здесь вычисления и внутреннее хранение данных
* а также регистрация и уведомление слушателей
* */

import java.util.LinkedList;
import java.util.List;

class Model implements Observable {

    private List<Observer> observers; // список слушателей

    private String op = "-"; // операция
    private String num1 = "1"; // первое число
    private String num2 = "2"; // второе число
    private String result = "1-2"; // результат

    // конструктор: создаем новый список для слушателей
    Model() {
        observers = new LinkedList<>();
    }

    // регистрация слушателя
    @Override public void registerObserver(Observer o) {
        observers.add(o);
    }

    // уведомление слушателей
    @Override public void notifyObservers(String message) {
        for (Observer observer : observers) {
            observer.notification(message);
        }
    }

    // выставляет операцию
    void setOp(String s) {
        op = s;
        notifyObservers("op");
    }

    // выставляет num1
    void setNum1(String s) {
        num1 = s;
    }

    // выставляет num2
    void setNum2(String s) {
        num2 = s;
    }

    // вычисляем результат
    void go() {
        result = num1 + op + num2;
        notifyObservers("go");
    }

    // отдаем результат
    String getResult() {
        return result;
    }

    String getOp() {
        return op;
    }
}
