package org.maxsite;
/*
* это представление: то, что выводится на форму
* */

import javafx.fxml.FXML;
import javafx.scene.control.Label;

class View implements Observer {

    // поля вывода
    @FXML private Label LabelResult;
    @FXML private Label LabelOp;

    // создаем модель здесь, поскольку это суперкласс для контролера
    Model model = new Model();

    // конструктор: регистрация на сообщения модели
    View() {
        model.registerObserver(this);
    }

    // уведомления от модели
    @Override public void notification(String message) {
        // разные уведомления под разный вывод
        if (message.equals("go")) {
            this.displayLabel(model.getResult());
        }
        else if (message.equals("op")) {
            this.displayOp(model.getOp());
        }
    }

    // выводит текст в LabelResult (результат)
    private void displayLabel(String s){
        LabelResult.setText("Результат: " + s);
    }

    // выводит текст в LabelOp (операция)
    private void displayOp(String s) {
        LabelOp.setText("Операция: " + s);
    }
}
